#! /usr/bin/env python3

from gi.repository import Gtk, Gdk

class Y901FullScreenTool(Gtk.Window):
    """
        Full Screen Toolbox
    """
    def __init__(self, parent, box, parent2, bar):
        """
            GtkWindow at GTK_WINDOW_POPUP
        """
        Gtk.Window.__init__(self, Gtk.WindowType.POPUP)
        # memory pointer
        self.p1 = parent
        self.p2 = parent2
        self.box = box
        self.bar = bar
        # Get Desktop Window Geometry
        root = Gdk.get_default_root_window()
        x, y, w, h = root.get_geometry()
        # move and resize
        height = box.get_allocated_height() + bar.get_allocated_height()
        self.set_size_request(w, height)
        self.y_pos = h - height
        self.move(0, self.y_pos)
        # Change parent
        vbox = Gtk.Box.new(Gtk.Orientation.VERTICAL, 0)
        self.box.reparent(vbox)
        self.bar.reparent(vbox)
        vbox.show_all()
        self.add(vbox)
        self.connect("destroy", self.on_destroy)

    def on_destroy(self, widget, data=None):
        """
            Return Parent
        """
        self.box.reparent(self.p1)
        self.p1.set_child_packing(self.box, False, True, 0, Gtk.PackType.END)
        self.bar.reparent(self.p2)
        self.p2.set_child_packing(self.bar, False, False, 0, Gtk.PackType.START)
        return True

