#!/usr/bin/env python3

from gi.repository import Gtk, Gdk

class Y901HeaderBar(Gtk.HeaderBar):
    def __init__(self):
        Gtk.HeaderBar.__init__(self)
        # Size Button
        self.sizebutton = Gtk.MenuButton.new()
        self.sizebutton.set_label("win")
        self.pack_start(self.sizebutton)
        # Aspect rate Button
        self.aspectbutton = Gtk.MenuButton.new()
        self.aspectbutton.set_label("default")
        self.pack_start(self.aspectbutton)
        # Preference button
        self.preferencebutton = Gtk.MenuButton.new()
        image_gear = Gtk.Image.new_from_icon_name("open-menu-symbolic", Gtk.IconSize.MENU)
        self.preferencebutton.set_image(image_gear)
        #print(dir(Gtk.Align))
        self.pack_end(self.preferencebutton)
        # Full Screen Button
        self.fullbutton = Gtk.Button.new()
        image_full = Gtk.Image.new_from_icon_name("view-fullscreen-symbolic", Gtk.IconSize.MENU)
        self.fullbutton.set_image(image_full)
        self.pack_end(self.fullbutton)
        #
        self.show_all()

    def create_sizemenu(self, accelgroup, strs, keys, callback):
        self.sizemenu = Gtk.Menu.new()
        for i, s in enumerate(strs):
            item = Gtk.MenuItem.new_with_label(s)
            item.show()
            item.connect("activate", callback, i)
            item.add_accelerator("activate", accelgroup, keys[i], 0, Gtk.AccelFlags.VISIBLE)
            self.sizemenu.append(item)
        self.sizebutton.set_popup(self.sizemenu)

    def create_aspectmenu(self, strs, callback):
        self.aspectmenu = Gtk.Menu.new()
        for i, s in enumerate(strs):
            item = Gtk.MenuItem.new_with_label(s)
            item.show()
            item.connect("activate", callback, i)
            self.aspectmenu.append(item)
        self.aspectbutton.set_popup(self.aspectmenu)

    def create_preferencebutton(self, accelgroup, strs, keys, callback):
        self.preferencemenu = Gtk.Menu.new()
        for i, s in enumerate(strs):
            item = Gtk.MenuItem.new_with_mnemonic(s)
            item.show()
            item.connect("activate", callback, i)
            item.add_accelerator("activate", accelgroup, keys[i], Gdk.ModifierType.CONTROL_MASK, Gtk.AccelFlags.VISIBLE)
            self.preferencemenu.append(item)
        self.preferencemenu.props.halign = Gtk.Align.CENTER
        self.preferencebutton.set_popup(self.preferencemenu)

