#!/usr/bin/env python3

from gi.repository import Gtk

style = """
MiniButton {
    -GtkButton-default-border : 0;
    -GtkButton-default-outside-border : 0;
    -GtkButton-inner-border: 0;
    -GtkWidget-focus-line-width : 0;
    -GtkWidget-focus-padding : 0;
    padding: 0;
}"""

class Y901MenuButton(Gtk.MenuButton):
    def __init__(self, items, initnum, func):
        Gtk.MenuButton.__init__(self)
        self.set_label(items[initnum])
        self.func = func
        # Menu
        self.menu = Gtk.Menu.new()
        self.set_popup(self.menu)
        self.create_menu(items)
        self.show()

    def create_menu(self, items):
        for menuitem in self.menu:
            self.menu.remove(menuitem)
        self.items = items
        for i, s in enumerate(items):
            item = Gtk.MenuItem.new_with_label(s)
            item.show()
            item.connect("activate", self.on_menu, i)
            self.menu.append(item)

    def change_label(self, num):
        self.set_label(self.items[num])

    def on_menu(self, widget, num):
        self.func(num)
        self.set_label(self.items[num])

class Y901MiniMenuButton(Y901MenuButton):
    __gtype_name__ = "MiniButton"
    def __init__(self, items, initnum, func):
        Y901MenuButton.__init__(self, items, initnum, func)
        self.set_direction(Gtk.ArrowType.UP)
        # css
        provider = Gtk.CssProvider()
        provider.load_from_data(style.encode("utf-8"))
        context = self.get_style_context()
        context.add_provider(provider, Gtk.STYLE_PROVIDER_PRIORITY_USER)
        self.set_relief(Gtk.ReliefStyle.NONE)
