#! /usr/bin/env python3

from gi.repository import Gtk, Gdk

class Y901StatusBar(Gtk.Box):
    """
        Instead GtkStatusbar
    """
    def __init__(self, owner, speedbutton, audiobutton):
        """
            @param owner: Resize Window
        """
        self._owner = owner
        Gtk.Box.__init__(self, orientation=Gtk.Orientation.VERTICAL)
        hbox = Gtk.Box.new(Gtk.Orientation.HORIZONTAL, 0)
        hbox.show()
        # Time Label
        self.timelabel = Gtk.Label("00:00/00:00")
        self.timelabel.show()
        hbox.pack_start(self.timelabel, False, False, 10)
        # Button
        hbox.pack_start(speedbutton, False, False, 10)
        hbox.pack_start(audiobutton, False, False, 10)
        # Dummy
        hbox.pack_start(Gtk.Label(), True, True, 0)
        # Grip
        grip = Gtk.DrawingArea()
        grip.show()
        grip.set_size_request(16, 16)
        grip.set_events(Gdk.EventMask.EXPOSURE_MASK | Gdk.EventMask.BUTTON_PRESS_MASK)
        #grip.connect("draw", self.on_grip_draw)
        grip.connect("button-press-event", self.on_grip_button_press_event)
        grip.connect("realize", self.on_grip_realize)
        hbox.pack_end(grip, False, False, 0)
        # pack
        hs = Gtk.Separator.new(Gtk.Orientation.HORIZONTAL)
        hs.show()
        self.pack_start(hs, False, False, 0)
        self.pack_start(hbox, False, False, 0)
        self.show()

    def on_grip_button_press_event(self, widget, event):
        """
            begin resize @ Toplevel Window
        """
        self._owner.begin_resize_drag(Gdk.WindowEdge.SOUTH_EAST, event.button,
                int(event.x_root), int(event.y_root), event.time)

    def on_grip_realize(self, widget, event=None):
        """
            cursor change
        """
        cur_grip = Gdk.Cursor(Gdk.CursorType.BOTTOM_RIGHT_CORNER)
        widget.props.window.set_cursor(cur_grip)

'''    def on_grip_draw(self, widget, cr):
        """
            Draw Resize Grip
        """
        width = widget.get_allocated_width()
        height = widget.get_allocated_height()
        Gtk.paint_resize_grip(widget.props.style, cr, Gtk.StateType.NORMAL, None, None,
                Gdk.WindowEdge.SOUTH_EAST, width - 16, height - 16, 16, 16 ) '''

