#! /usr/bin/env python3

from gi.repository import Gtk, Gdk, GLib

class Y901ToolBox(Gtk.Box):
    """
        ToolBox
    """
    def __init__(self):
        Gtk.Box.__init__(self, orientation=Gtk.Orientation.VERTICAL)
        # SeekBar
        self.seekadj = Gtk.Adjustment(0.0, 0.0, 100.0, 1.0, 1.0, 1.0)
        self.seekbar = Gtk.Scale.new(Gtk.Orientation.HORIZONTAL, self.seekadj)
        self.seekbar.set_events(
                Gdk.EventMask.BUTTON_PRESS_MASK | 
                Gdk.EventMask.BUTTON_RELEASE_MASK | 
                Gdk.EventMask.STRUCTURE_MASK )
        self.seekbar.set_draw_value(False)
        # volume bar
        self.volumeadj = Gtk.Adjustment(50.0, 0.0, 101.0, -1.0, 1.0, 1.0)
        self.volumebar = Gtk.Scale.new(Gtk.Orientation.HORIZONTAL, self.volumeadj)
        self.volumebar.set_value_pos(Gtk.PositionType.RIGHT)
        self.volumebar.set_size_request(100, -1)
        self.volumebar.set_digits(0)
        self.volumebar.set_show_fill_level(True)
        self.volumebar.set_events(
                Gdk.EventMask.BUTTON_PRESS_MASK | 
                Gdk.EventMask.BUTTON_RELEASE_MASK | 
                Gdk.EventMask.STRUCTURE_MASK )
        # ctrl pack
        buttonbox = Gtk.Box.new(Gtk.Orientation.HORIZONTAL, 0)
        # images
        dirname = GLib.path_get_dirname( __file__ )
        self.playimg = []
        for i, img in enumerate(["pausebutton", "stopbutton", "playlist", "rep_rdm", "rep_all", "rep_one", "playbutton"]):
            path = GLib.build_filenamev([dirname, "img", "{0}.xpm".format(img)])
            icon = Gtk.Image.new_from_file(path)
            if i == 6:
                self.playimg.append(icon)
                break
            elif i == 0:
                b = Gtk.Button()
                buttonbox.pack_start(b, False, False, 0)
                self.playimg.append(icon)
                self.play = b
            elif i == 1:
                b = Gtk.Button()
                buttonbox.pack_start(b, False, False, 0)
                self.stop = b
                buttonbox.pack_start(self.volumebar, False, False, 0)
            elif i == 2:
                b = Gtk.Button()
                buttonbox.pack_end(b, False, False, 0)
                self.playlist = b
            else:
                b = Gtk.ToggleButton()
                buttonbox.pack_end(b, False, False, 0)
                if i == 3:
                    self.rdm = b
                elif i == 4:
                    self.all = b
                elif i == 5:
                    self.one = b
            b.set_focus_on_click(False)        # no focus
            b.set_relief(Gtk.ReliefStyle.NONE) # Flat Button
            b.set_image(icon)
        # packing
        self.pack_start(self.seekbar, True, True, 0)
        self.pack_start(buttonbox, False, False, 0)
        # self
        self.num = 0
        self.set_enable_ctrl(False)
        self.show_all()

    def change_img(self, num):
        if self.num != num:
            self.play.set_image(self.playimg[num])
            self.num = num

    def set_enable_ctrl(self, b):
        self.play.set_sensitive(b)
        self.stop.set_sensitive(b)
        self.seekbar.set_sensitive(b)

